varying vec4 viewVec;
varying vec3 normal;

uniform samplerCube cubeMap;

const float refractRatio = 1.5; 
//const float refractRatio = 1.0; 

void main (void)
{
    

    float R0 = pow(1.0 - refractRatio, 2.0) / pow(1.0 + refractRatio, 2.0);
    vec3 vVec = normalize(viewVec.xyz);
    vec3 n = normalize(normal);

    vec4 viewReflectVec = 
        vec4(reflect(vVec,n), 0.0); 
    
    vec4 diffuseReflectColor =
        textureCube(cubeMap, 
	vec4(gl_TextureMatrix[0] * vec4(viewReflectVec)).xyz);
    
    vec4 viewRefractVec =  
        vec4(-refract(-vVec, n, refractRatio), 0.0);

    //vec4 diffuseRefractColor =
    //    textureCube(cubeMap, vec3(viewRefractVec));
    
    //vec4 diffuseRefractColor =
    //    textureCube(cubeMap, vec4(gl_TextureMatrix[0] * vec4(vVec, 0.0)).xyz);
    vec4 diffuseRefractColor =
        textureCube(cubeMap, vec4(gl_TextureMatrix[0] * viewRefractVec).xyz);
    
    //float fresnel = R0 + (1.0 - R0) * pow(1.0 - dot(vVec, n), 5.0);
    float fresnel = 1.0 / pow(1.0 + dot(vVec, n), 2.0);
    //fresnel = 0.0;
    fresnel = 1.0;
    gl_FragColor = mix(diffuseRefractColor, diffuseReflectColor, fresnel);
    //gl_FragColor = diffuseRefractColor;
}

