varying vec3 normal, viewVec, reflectVec[2];
varying vec3 lightVec[2];

uniform float shininess;

void main()
{
	float cosTheta[2];
	float cosAlpha;
	vec4 color;

	vec3 n = normalize(normal);

	cosTheta[0] = max(dot(n, normalize(lightVec[0])), 0.0);
	cosTheta[1] = max(dot(n, normalize(lightVec[1])), 0.0);

	color = (gl_LightModel.ambient * gl_FrontMaterial.ambient) +
		(gl_FrontMaterial.ambient * gl_LightSource[0].ambient) + 
		(gl_FrontMaterial.ambient * gl_LightSource[1].ambient);

	if (cosTheta[0] > 0.0)
	{
		color += gl_FrontMaterial.diffuse * gl_LightSource[0].diffuse * 
			cosTheta[0];

		cosAlpha = max(dot(normalize(reflectVec[0]), 
			normalize(viewVec)), 0.0);

		color += gl_FrontMaterial.specular * 
		gl_LightSource[0].specular * pow(cosAlpha, shininess);
	}

	if (cosTheta[1] > 0.0)
	{
		color += gl_FrontMaterial.diffuse * gl_LightSource[1].diffuse * 
			cosTheta[1];

		cosAlpha = max(dot(normalize(reflectVec[1]), 
			normalize(viewVec)), 0.0);

		color += gl_FrontMaterial.specular * 
			gl_LightSource[1].specular * pow(cosAlpha, shininess);
	}

	gl_FragColor = color;
}

