varying vec3 normal, viewVec, reflectVec[2];
varying vec3 lightVec[2];

void main()
{
	normal = normalize(gl_NormalMatrix * gl_Normal);

	// Not really needed to be calculated here, since
	// lights are directional..
	lightVec[0] = normalize(vec3(gl_LightSource[0].position));
	lightVec[1] = normalize(vec3(gl_LightSource[1].position));

	reflectVec[0] = normalize(-reflect(lightVec[0], normal));
	reflectVec[1] = normalize(-reflect(lightVec[1], normal));
    
	viewVec = normalize(-vec3(gl_ModelViewMatrix * gl_Vertex));
    
	gl_Position = ftransform();
}
