#ifndef _MESHGEN_H
#define _MESHGEN_H

#define GRID_SIZE 40
#define SPACE_SIZE 10.0f

#define CUBE_SIZE (SPACE_SIZE / GRID_SIZE)
#define POS_TO_INDEX(p) ((int) ((p) / CUBE_SIZE) )

#define THRESHOLD 0.25f

typedef point_t vector_t;

typedef struct {
    point_t p;      /* point */       
    vector_t n;     /* vertex normal */
    float f_val;    /* field value */
} vertex_t;

struct gridcell_s {
    vertex_t v[8];
    char visited;
    struct gridcell_s *xl, *xh, *yl, *yh, *zl, *zh;
};

typedef struct gridcell_s gridcell_t;

/* function prototypes */
void init_grid();
/* void calc_fval(); */
inline void process_cell(gridcell_t *cell, metaball_t *balls);
gridcell_t **find_intersected_cubes(metaball_t *balls);
inline void clean_visited();
inline void make_mesh(gridcell_t *cell, metaball_t *balls); 

void calc_mesh(metaball_t *balls);

#endif

